$(document).ready(function () {
  app.initialized().then(function(_client) {
    window.client = _client;
    client.events.on('app.activated', function() {
      client.events.on("ticket.propertiesUpdated", updateEventCallback);
    }, function () {
      displayNotification("Error Occured on activating SUBJECT UPDATE APP");
    });
  }, function () {
    displayNotification("Error Occured on initializing SUBJECT UPDATE APP");
  });

  function updateEventCallback() {
    client.data.get("ticket").then(function(data) {
      var ticket = data.ticket;
      client.request.invoke("onTicketUpdateHandler", ticket).catch(function() {
        // console.log(error);
      });
    }, function() {
      displayNotification("SUBJECT UPDATE APP - failed to get ticket information");
    });
  }

  function displayNotification(message) {
    client.interface.trigger("showNotify", {
      type: "danger",
      message: message
    });
  }
});
