var header = require("./lib/header");

exports = {
  onTicketCreateCallback: function(payload) {
    
    var ticket = payload.data.ticket;
    var category = ticket.custom_fields.cf_product_type1_2059902;
    var reason = ticket.custom_fields.cf_new_reason_for_interaction_2059902;
    if (category && reason) {
      var subject = `${category} - ${reason}`;
      var subReason = ticket.custom_fields.cf_new_subreason_for_interaction_2059902;
      if (subReason)
        subject += ` - ${subReason}`;
      if (ticket.subject != subject){
        var options = header.getHeader();
        options["json"] = {
          subject: subject
        };
        var ticketId = ticket.id;
        var url = `https://<%= iparam.domain %>.freshdesk.com/api/v2/tickets/${ticketId}`;
        $request.put(url, options).then(function() {
          console.log(`${ticketId} - Subject updated in creation`);
        }, function(error) {
          console.log(`${ticketId} - Error on updating subject`);
          console.log(error);
        });
      }
    }
  },
  onTicketUpdateCallback: function(payload) {
    //Finding fields that are changed
    var ticket = payload.data.ticket;
    var category = ticket.custom_fields.cf_product_type1_2059902;
    var reason = ticket.custom_fields.cf_new_reason_for_interaction_2059902;
    if (category && reason) {
      var subject = `${category} - ${reason}`;
      var subReason = ticket.custom_fields.cf_new_subreason_for_interaction_2059902;
      if (subReason)
        subject += ` - ${subReason}`;
      if (ticket.subject != subject){
        var options = header.getHeader();
        options["json"] = {
          subject: subject
        };
        var ticketId = ticket.id;
        var url = `https://<%= iparam.domain %>.freshdesk.com/api/v2/tickets/${ticketId}`;
        $request.put(url, options).then(function() {
          console.log(`${ticketId} - Subject updated in updation`);
        }, function(error) {
          console.log(`${ticketId} - Error on updating subject`);
          console.log(error);
        });
      }
    }
  }
};